// Sample02 application
// 2011/07/03
// Copyrigh(c)t jjworkshop by HIRO.
// Sencha Touch サンプルアプリケーション

/*
--------------------------------------
 Sencha Touch アプリケーション
-------------------------------------- */ 

// データモデル
Ext.regModel('sampleData', {
	fields: ['loca', 'name', 'tel']
});

// データストア
var dataStore = new Ext.data.Store({
	model: 'sampleData',
	data : [
		{loca: '東京都', name: '山田' , tel: '080-1346-****'},
		{loca: '埼玉県', name: '佐藤' , tel: '090-2346-****'},
		{loca: '宮崎県', name: '後藤' , tel: '080-2346-****'},
		{loca: '大阪府', name: '権田' , tel: '070-9346-****'},
		{loca: '奈良市', name: '井崎' , tel: '020-2246-****'},
		{loca: '香川県', name: '薦田' , tel: '050-2546-****'},
		{loca: '山口県', name: '蓮田' , tel: '090-2846-****'},
		{loca: '大分県', name: '友夏' , tel: '080-2146-****'}
	],
	autoLoad: true
});

// 表示用テンプレート（リスト表示の行データ）
var tpl = new Ext.XTemplate(
	'<tpl for=".">',
		'<div class="selecter">',
		'<table><tr><td><img src="./photo.png"/></td><td>{loca}</td></tr>',
		'<tr><td>{name}</td><td>{tel}</td></tr></table>',
		'</div>',
	'</tpl>',
	'<div class="x-clear"></div>'
);


// アプリケーション処理
var app = Ext.setup({
	fullscreen: true,
	icon: 'icon.png',
	preloadImages: [
		"./photo.png"
	],
	onReady: function() {

		/*
		--------------------------------------
		 リストパネル処理
		-------------------------------------- */ 

		// データリストビュー
		var listView = new Ext.DataView({
			fullscreen: true,
			autoHeight: true,
			itemSelector: 'div.selecter',
			emptyText: '<div class="notData">データがありません。</div>',
			singleSelect: true,
			store: dataStore,
			tpl: tpl,
			isEdit: false,
			listeners: { 
				itemswipe: {
					// スワイプ：削除
					fn: function (view, idx, el, e) {
						Ext.Msg.alert(null, idx + "行スワイプ", Ext.emptyFn);
					}
				},
				itemdoubletap: {
					// ダブルタップ：
					fn: function (view, idx, el, e) {
						Ext.Msg.alert(null, idx + "行Ｗタップ", Ext.emptyFn);
					}
				}
			}
		});
		
		// データリスト表示パネル
		var listPanel = new Ext.Panel({
			fullscreen: true,
			monitorOrientation: true,
			nowPage: 1,
			newPage: -1,
			dockedItems: [listView],
			showBounceInfo: function (isShow, pos) {
				// 跳ねっ返りの文言を表示
				if (isShow)	{
					// 表示
					var msg = 'top' == pos ? '<p>▲&nbsp;前ページ</p>' : '<p>▼&nbsp;次ページ</p>';
					this.BounceInfoPos = pos;
					if (this.BounceInfoPanel == null)	{
						this.BounceInfoPanel = new Ext.Panel(
						{
							floating: true,
							id: 'bounceInfo',
							width: 250,
							height: 40,
							centered: true,
							html: msg,
							listeners: { 
								show: {
									fn: function () {
										var pnSize = listPanel.getSize();
										var x = (pnSize.width - this.width) / 2;
										var y = 0;
										if (listPanel.BounceInfoPos == 'top')	{
											y = 10;
										}
										else {
											y = pnSize.height - this.height - 10;
										}
										this.setPosition(x , y);
									}
								}
							}
						});
					}
					this.BounceInfoPanel.update(msg);
					this.BounceInfoPanel.show();
				}
				else {
					// 消す
					if (this.BounceInfoPanel != null)	{
						this.BounceInfoPanel.hide();
					}
				}
			}
		});

		// リストビューの上下の跳ねっ返りを処理
		listView.scroller.on('offsetchange', function (obj, offset) {
			// オフセットを計算
			obj.pageMode = 0;
			if (offset.y >= 0) {
				if (offset.y > 60)	{
					// 上で跳ねっ返りON
					obj.pageMode = -1;
					listPanel.showBounceInfo(true, 'top');
				}
				else listPanel.showBounceInfo(false);
			}
			else {
				var delta = Math.abs(offset.y - listPanel.height) - obj.size.height;
				if (delta > 60)	{
					// 下で跳ねっ返りON
					obj.pageMode = 1;
					listPanel.showBounceInfo(true, 'bottm');
				}
				else listPanel.showBounceInfo(false);
			}
		});
		listView.scroller.on('bounceStart', function (obj) {
			// 跳ねっ返り開始
			if (obj.pageMode == -1 || obj.pageMode == 1)	{
				listPanel.newPage = listPanel.nowPage + obj.pageMode;
			}
		});
		listView.scroller.on('bounceEnd', function (obj) {
			// 跳ねっ返り終了（bounceStartで処理するとイベントが残るので、こっちで処理）
			listPanel.showBounceInfo(false);
			if (listPanel.newPage != -1)	{
				// このタイミングで前後ページデータを読み込む処理をする
				// （データ読み込み処理）
				console.log('Next page=' + listPanel.newPage);
				// 次に備える
				listPanel.nowPage = listPanel.newPage;
				listPanel.newPage != -1;
			}
		});

	}
});

